program str155n10;

{$APPTYPE CONSOLE}

uses
  SysUtils,windows;
type
  Tsession = array[1..10,1..5] of record            //  
                                  name: string[10]; // 
                                  mark: 1..5;       //
                                  end;
  student = record                //   
            FIO: string[40];      // , , 
            curs: 1..5;           // 
            group: 1..9;          // 
            results: Tsession;    //   
            end;
 TFile= file of student ; //  ,    
var k:integer;
    fname: string;
    f:TFile;
//--
procedure Read_student(var st:student);       //    
var i,j:integer;                              // i -  , j -  
begin
with st do
 begin
  write(' : '); readln(FIO);        //  
  write(' : '); readln(curs);      //  
  write(' : '); readln(group);   //  
  writeln('  :');
  i:=1;                                       //  =1
  repeat
  writeln(' ',i,': ');                //    
   for j:=1 to 5 do                           //     
    begin
     write(' ',j,'- : '); readln(results[i,j].name); // 
     write('  ',j,'- : '); readln(results[i,j].mark);  // 
    end;
  inc(i);
  until (i=curs*2+1);  //   
 end;                                                //  -        .
writeln(' !');
end;
//--
procedure write_student(var st:student);             //  
var i,j:integer;
begin
with st do
 begin
  writeln(FIO,', ',curs,' , ',group,' .');  //    
  for i:=1 to curs*2 do                               //  
   begin
    write('   ',i,': ');
    for j:=1 to 5 do
     write(results[i,j].name,': ',results[i,j].Mark,', ');
    writeln;
   end;
 end;
end;
//--
procedure New_file(var f:tfile; var name:string);    //   
var yn:char;
begin
 writeln('_____________________');
 write('  : ');
 readln(name);                                       //  
 if name='' then writeln('  !') else    //     
   if fileexists(name) then                          //    
    begin
     write('    , ? (y/n): ');
     readln(yn);
     if yn in ['y','Y','',''] then
      begin                                          //   ,   
       assign(f,name);
       rewrite(f);                                   //     
       writeln(' "',name,'" !');
       closefile(f);
      end;
    end
   else
    begin
     assign(f,name);
     rewrite(f);
     writeln(' "',name,'" !');
     closefile(f);
    end;

end;
//--
procedure Open_file(var f:tfile; var name:string);      //   
begin
 writeln('_____________________');
 write('   : ');
 readln(name);                                          //     
 if (name='') then writeln('  ,    .') //     
 else if not fileexists(name) then
  begin
   writeln('  !');                        //     
   name:='';
  end
 else
  begin
   assignfile(f,name);
   reset(f);                                            //   
   closefile(f);
   writeln(' "',name,'" !');
  end
end;
//--
procedure View_file(var f:tfile; var name:string);      //   
var i:integer;
    rec:student;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   reset(f);
   if eof(f) then writeln(' .')                 //    , ,     
    else
     for i:=0 to Filesize(f)-1 do                       //    
      begin
       read(f,rec);                                     //      
       write('',i+1,' ');                              //   
       write_student(rec);                              //     
      end;
    writeln(' !');
  end;
end;
//--
procedure Add_rec(var f:tfile; var name:string);        //  
var rec:student;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   reset(f);
   seek(f,Filesize(f));                                 //    
   Read_student(rec);                                   //      
   write(f,rec);                                        //     
   writeln(' !');                        //   
   closefile(f);                                        //  
  end;
end;
//--
procedure Del_rec(var f:tfile; var name:string);
var n:integer;
    rec:student;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   reset(f);                                              //    
   write('  ,   : ');
   readln(n);
   if n<1 then writeln('  .') else     //    
    begin
     dec(n);                     //   1, ..     0 
     write('... ');
     seek(f,FileSize(f)-1);      //   
     read(f,rec);                //    
     seek(f,n);                  //    
     write(f,rec);               //       rec
     seek(f,Filesize(f)-1);      //   
     Truncate(f);                //  -   
     writeln('!');        //  
     closefile(f);               // 
    end;
  end;
end;
//--
procedure Change_rec(var f:tfile; var name:string);
var n:integer;
    rec:student;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   reset(f);
   write('  ,   : ');
   readln(n);                                             //     
   if n<1 then writeln('  .') else     
    begin
     dec(n);                                              //   1, ..     0
     seek(f,n);                                           //    
     writeln('     ',n+1);
     read_student(rec);                                   //    
     write(f,rec);                                        //       N
     writeln(' !');
     closefile(f);
    end;
  end;
end;
//--
procedure Type_text(var f:tfile; var name:string); //     
var n,i,j:integer;
    rec:student;
    f2:textfile;
    name2,str:string;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   reset(f);
   write('   ,    : ');
   readln(name2);                                                    //   
   if name2='' then writeln('  ') else                  //  
   begin
    assign(f2,name2);
    rewrite(f2);                                                     //    
    write('  , ... ');
    for n:=0 to FileSize(f)-1 do                                    //   
    begin
     read(f,rec);                                                    //    
     str:=rec.fio+': '+IntToStr(rec.curs)+' '+IntToStr(rec.group)+' '; //   ,   
     writeln(f2,str);                                                //      
     for i:=1 to rec.curs*2 do                                       //  
      begin
       for j:=1 to 5 do                                              //     
        begin
         str:=rec.results[i,j].name+': '+IntToStr(rec.results[i,j].Mark)+' '; //      
         write(f2,str);                                              //     
         end;
       writeln(f2);                                                  //       
      end;
    end;
    writeln('!');
    closefile(f2);
    closefile(f);
   end;
  end;
end;
//--
function get_word(var f2:textfile):string;       //         
var ch:char;
begin
 result:='';
 read(f2,ch);                                    //  
 while ch<>':' do                                //   -  
 begin
  result:=result+ch;                             //    
  read(f2,ch);                                   //   
 end; 
end;
//--
procedure Text_type(var f:tfile; var name:string); //     
var i,j:integer;
    rec:student;
    f2:textfile;
    name2:string;
    ch:char;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   reset(f);                                     //  
   write('   ,    : ');
   readln(name2);                                //   
   if name2='' then writeln('  ') else
    if not fileexists(name2) then writeln('   !') else
     begin
      assignfile(f2,name2);
      reset(f2);                                 //    
      write('  , ... ');
      while not eof(f2) do
       begin
        rec.FIO:=copy(get_word(f2),1,40);        //  
        read(f2,rec.curs); readln(f2,rec.group); //    -   
        for i:=1 to rec.curs*2 do                //   (  )
        begin
         for j:=1 to 5 do                        //  
          begin
           rec.results[i,j].name:=get_word(f2);  //  
           read(f2,rec.results[i,j].Mark);       // 
          end;
         readln(f2);                             //   ,.. 
        end;
        write(f,rec);                            //     
       end;
      writeln('!');
      closefile(f2);
      closefile(f);
     end;
  end;
end;
//--
procedure Task(var f:tfile; var name:string);  //      , 
var n,i:integer;                               //      
    rec:student;
    f2:tfile;
    b,c,d:boolean;
    name2:string;
begin
 writeln('_____________________');
 if name='' then writeln('   !    !')
 else
  begin
   write('    : '); readln(name2); //  ,    
   if name2='' then writeln('!  !')
   else
    begin
     reset(f);                                                  //    
     assign(f2,name2);
     rewrite(f2);                                               //    
     writeln(' "',name2,'" !');
     write(' ,  ... ');
     for n:=0 to Filesize(f)-1 do                               //     
      begin
       b:=true; c:=true; i:=1; d:=true;                         // 
       seek(f,n);                                               //   
       read(f,rec);                                             //   
       while (i<=5) and d do                                    //      
        begin
         if (rec.results[rec.curs*2,i].mark<4) then d:=false;   //d ,    <4  
         inc(i);                                                //   
        end;
       i:=1;
       if d then                                                //   , 
        begin
         while c and (i<=5) do                                   //  
          begin
           if rec.results[rec.curs*2,i].mark=4 then              //  , 
           if b=true then b:=false else c:=false;                //  ,    b,     
           inc(i);                                               //   
          end;
         if c then                                               //    
         begin
          writeln('  ',n+1);
          write(f2,rec);                                         // 
         end;
       end;
      end;
     closefile(f);
     closefile(f2);
    end;
  end;
end;
//--
begin
SetConsoleCP(1251);
SetConsoleOutputCP(1251);
fname:='';
 repeat                                    // 
  writeln('_____________________');
  writeln(':');
  writeln('1 -  ');
  writeln('2 -   ');
  writeln('3 -  ');
  writeln('4 -  ');
  writeln('5 -  ');
  writeln('6 -   ');
  writeln('7 -       ,        ');
  writeln('8 -     ');
  writeln('9 -     ');
  writeln('0 - ');
  write(' : ');
  repeat
   readln(k);                                            //  
   if not k in [0..9] then writeln(' '); //  
  until k in [0..9];
  case k of                                              //  
    1: New_file(f,fname);
    2: Open_file(f,fname);
    3: Add_rec(f,fname);
    4: Del_rec(f,fname);
    5: Change_rec(f,fname);
    6: View_file(f,fname);
    7: Task(f,fname);
    8: Type_Text(f,fname);
    9: Text_Type(f,fname);
    end;
  until k=0;                                            //  
end.

